// AnnotDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "BkView.h"
#include "AnnotDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CAnnotDlg dialog
CAnnotDlg::CAnnotDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAnnotDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAnnotDlg)
	m_s = _T("");
	m_s0 = _T("");
	m_s10 = _T("");
	m_s11 = _T("");
	m_s20 = _T("");
	m_s30 = _T("");
	m_s40 = _T("");
	m_s50 = _T("");
	m_s21 = _T("");
	m_s31 = _T("");
	m_s41 = _T("");
	m_s51 = _T("");
	m_OK = FALSE;
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_ANNOT,pParent);
}
void CAnnotDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAnnotDlg)
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Text(pDX, IDC_EDIT0, m_s0);
	DDX_Text(pDX, IDC_EDIT10, m_s10);
	DDX_Text(pDX, IDC_EDIT11, m_s11);
	DDX_Text(pDX, IDC_EDIT20, m_s20);
	DDX_Text(pDX, IDC_EDIT30, m_s30);
	DDX_Text(pDX, IDC_EDIT40, m_s40);
	DDX_Text(pDX, IDC_EDIT50, m_s50);
	DDX_Text(pDX, IDC_EDIT21, m_s21);
	DDX_Text(pDX, IDC_EDIT31, m_s31);
	DDX_Text(pDX, IDC_EDIT41, m_s41);
	DDX_Text(pDX, IDC_EDIT51, m_s51);
	DDX_Check(pDX, IDC_CHECK1, m_OK);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAnnotDlg, CDialog)
	//{{AFX_MSG_MAP(CAnnotDlg)
	ON_EN_SETFOCUS(IDC_EDIT0, OnSetfocusEdit0)
	ON_EN_SETFOCUS(IDC_EDIT10, OnSetfocusEdit10)
	ON_EN_SETFOCUS(IDC_EDIT11, OnSetfocusEdit11)
	ON_EN_SETFOCUS(IDC_EDIT20, OnSetfocusEdit20)
	ON_EN_SETFOCUS(IDC_EDIT21, OnSetfocusEdit21)
	ON_EN_SETFOCUS(IDC_EDIT30, OnSetfocusEdit30)
	ON_EN_SETFOCUS(IDC_EDIT31, OnSetfocusEdit31)
	ON_EN_SETFOCUS(IDC_EDIT40, OnSetfocusEdit40)
	ON_EN_SETFOCUS(IDC_EDIT41, OnSetfocusEdit41)
	ON_EN_SETFOCUS(IDC_EDIT50, OnSetfocusEdit50)
	ON_EN_SETFOCUS(IDC_EDIT51, OnSetfocusEdit51)
	ON_BN_CLICKED(IDEFFACER_RUB, OnEffacerRub)
	ON_BN_CLICKED(IDEFFACERTOUT, OnEffacertout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CAnnotDlg message handlers
void CAnnotDlg::PostNcDestroy()
{
	delete this;
}
//________________________________________
void CAnnotDlg::MAJ() 
{
	//Met  jour la structure annotation du document
	UpdateData(TRUE);
	class CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->a.OK=m_OK;
		//N de rubrique
		pDoc->a.a[1]=m_s10;
		pDoc->a.a[2]=m_s20;
		pDoc->a.a[3]=m_s30;
		pDoc->a.a[4]=m_s40;
		pDoc->a.a[5]=m_s50;
		//Lgende
		pDoc->a.s[0]=m_s0;
		pDoc->a.s[1]=m_s11;
		pDoc->a.s[2]=m_s21;
		pDoc->a.s[3]=m_s31;
		pDoc->a.s[4]=m_s41;
		pDoc->a.s[5]=m_s51;
		/*
		CRect r;
		r.left=0;r.right=pDoc->m_iLarg;r.top=0;r.bottom=pDoc->m_iHaut;
		pDoc->m_pView->InvalidateRect(r,FALSE);
		pDoc->UpdateAllViews(pDoc->m_pView,(LPARAM)(LPCRECT)r);
		*/
		pDoc->UpdateAllViews(NULL);
	}
}
//________________________________________
void CAnnotDlg::Ecrit() 
{
	class CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		//Ecrit les donnes du document vers les champs de la bote de dialogue
		//N de rubrique
		m_s10=pDoc->a.a[1];
		m_s20=pDoc->a.a[2];
		m_s30=pDoc->a.a[3];
		m_s40=pDoc->a.a[4];
		m_s50=pDoc->a.a[5];
		//Lgende
		m_s0=pDoc->a.s[0];
		m_s11=pDoc->a.s[1];
		m_s21=pDoc->a.s[2];
		m_s31=pDoc->a.s[3];
		m_s41=pDoc->a.s[4];
		m_s51=pDoc->a.s[5];
		if (pDoc->a.x[1]==1e10) GetDlgItem(IDC_EDIT10)->EnableWindow(FALSE); else GetDlgItem(IDC_EDIT10)->EnableWindow(TRUE);
		if (pDoc->a.x[2]==1e10) GetDlgItem(IDC_EDIT20)->EnableWindow(FALSE); else GetDlgItem(IDC_EDIT20)->EnableWindow(TRUE);
		if (pDoc->a.x[3]==1e10) GetDlgItem(IDC_EDIT30)->EnableWindow(FALSE); else GetDlgItem(IDC_EDIT30)->EnableWindow(TRUE);
		if (pDoc->a.x[4]==1e10) GetDlgItem(IDC_EDIT40)->EnableWindow(FALSE); else GetDlgItem(IDC_EDIT40)->EnableWindow(TRUE);
		if (pDoc->a.x[5]==1e10) GetDlgItem(IDC_EDIT50)->EnableWindow(FALSE); else GetDlgItem(IDC_EDIT50)->EnableWindow(TRUE);
		UpdateData(FALSE);
	}
}
//__________________________________________________
BOOL CAnnotDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	m_pApp=(CBkApp*)AfxGetApp();
	//N de la fentre active
	class CBkDoc *pDoc=m_pApp->GetDocument();

	if (pDoc!=NULL)
	{
		m_iNoL=0;
		m_s.Format("Pour dfinir la position, cliquer avec la souris...");
		m_OK=pDoc->a.OK;
		//Ecrit les donnes du document vers les champs de la bote de dialogue
		Ecrit();
	}
	return TRUE;
}
//________________________________________
void CAnnotDlg::OnCancel() 
{
	//Met  jour la structure annotation du document
	MAJ();	
	m_pApp->m_pAnnotDlg=NULL;
	
	CDialog::OnCancel();
}
//________________________________________
void CAnnotDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CAnnotDlg::Fermer(void)
{
	m_pApp->m_pAnnotDlg=NULL;
	CDialog::OnCancel();
}
//________________________________________
void CAnnotDlg::Affecte(short x,short y)
{
	class CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		MAJ();
		//Dans le repre de la fentre...
		m_s.Format("Clic pour position annotation n%d: x:%d, y:%d",m_iNoL,x,y);
		pDoc->a.x[m_iNoL]=x;
		pDoc->a.y[m_iNoL]=y;
		//Ecrit les donnes du document vers les champs de la bote de dialogue
		Ecrit();	
	}
}
//________________________________________
void CAnnotDlg::Affecte1(float x,float y)
{
	class CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		MAJ();
		//Dans le repre de la fentre...
		m_s.Format("Clic pour position annotation n%d: x:%1.2f, y:%1.2f",m_iNoL,x,y);
		pDoc->a.x[m_iNoL]=x;
		pDoc->a.y[m_iNoL]=y;
		//Ecrit les donnes du document vers les champs de la bote de dialogue
		Ecrit();	
	}
}
//________________________________________
void CAnnotDlg::OnSetfocusEdit0() 
{
	//Met  jour la structure annotation du document
	MAJ();	

	m_iNoL=0;
	m_s.Format("Cliquer dans fentre pour df. pos. cadre...");	
	UpdateData(FALSE);
}
//__________________________________________________
void CAnnotDlg::OnSetfocusEdit10() 
{
	//Met  jour la structure annotation du document
	MAJ();	

	m_iNoL=1;
	m_s.Format("Cliquer dans fentre df. pos. annotation n1...");	
	UpdateData(FALSE);
}
//__________________________________________________
void CAnnotDlg::OnSetfocusEdit11() 
{
	//Met  jour la structure annotation du document
	MAJ();	
	m_iNoL=1;
	m_s.Format("Cliquer dans fentre df. pos. annotation n1...");	
	UpdateData(FALSE);
}
//__________________________________________________
void CAnnotDlg::OnSetfocusEdit20() 
{
	//Met  jour la structure annotation du document
	MAJ();	
	m_iNoL=2;
	m_s.Format("Cliquer dans fentre df. pos. annotation n2...");	
	UpdateData(FALSE);
}
//__________________________________________________
void CAnnotDlg::OnSetfocusEdit21() 
{
	//Met  jour la structure annotation du document
	MAJ();	
	m_iNoL=2;
	m_s.Format("Cliquer dans fentre df. pos. annotation n2...");	
	UpdateData(FALSE);
}
//__________________________________________________
void CAnnotDlg::OnSetfocusEdit30() 
{
	//Met  jour la structure annotation du document
	MAJ();	
	m_iNoL=3;
	m_s.Format("Cliquer dans fentre df. pos. annotation n3...");	
	UpdateData(FALSE);
}
//__________________________________________________
void CAnnotDlg::OnSetfocusEdit31() 
{
	//Met  jour la structure annotation du document
	MAJ();	
	m_iNoL=3;
	m_s.Format("Cliquer dans fentre df. pos. annotation n3...");	
	UpdateData(FALSE);
}
//__________________________________________________
void CAnnotDlg::OnSetfocusEdit40() 
{
	//Met  jour la structure annotation du document
	MAJ();	
	m_iNoL=4;
	m_s.Format("Cliquer dans fentre df. pos. annotation n4...");	
	UpdateData(FALSE);
}
//__________________________________________________
void CAnnotDlg::OnSetfocusEdit41() 
{
	//Met  jour la structure annotation du document
	MAJ();	
	m_iNoL=4;
	m_s.Format("Cliquer dans fentre df. pos. annotation n4...");	
	UpdateData(FALSE);
}
//__________________________________________________
void CAnnotDlg::OnSetfocusEdit50() 
{
	//Met  jour la structure annotation du document
	MAJ();	
	m_iNoL=5;
	m_s.Format("Cliquer dans fentre df. pos. annotation n5...");	
	UpdateData(FALSE);
}
//__________________________________________________
void CAnnotDlg::OnSetfocusEdit51() 
{
	//Met  jour la structure annotation du document
	MAJ();	
	m_iNoL=5;
	m_s.Format("Cliquer dans fentre df. pos. annotation n5...");	
	UpdateData(FALSE);
}
//__________________________________________________
void CAnnotDlg::OnEffacerRub() 
{
	class CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->a.x[m_iNoL]=1e10;	
		pDoc->a.y[m_iNoL]=1e10;	
	}
	if (m_iNoL==0) m_s0="";
	if (m_iNoL==1) m_s11="";
	if (m_iNoL==2) m_s21="";
	if (m_iNoL==3) m_s31="";
	if (m_iNoL==4) m_s41="";
	if (m_iNoL==5) m_s51="";
	UpdateData(FALSE);
	//Met  jour la structure annotation du document
	MAJ();	
	//Ecrit les donnes du document vers les champs de la bote de dialogue
	Ecrit();
}
//__________________________________________________
void CAnnotDlg::OnEffacertout() 
{
	short i;
	class CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		for (i=0;i<6;i++)
		{
			pDoc->a.x[i]=1e10;	
			pDoc->a.y[i]=1e10;	
			pDoc->a.s[i]="";	
			pDoc->a.a[i].Format("[%c]",i+64);	
		}
		//Ecrit les donnes du document vers les champs de la bote de dialogue
		Ecrit();
	}
}
