// Bk.h : main header file for the BK application
//
#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols
#include "vicdefs.h"
//________________________________________
// CBkApp:
// See Bk.cpp for the implementation of this class
//
class CBkApp : public CWinApp
{
public:
	CBkApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBkApp)
	public:
	virtual BOOL InitInstance();
	virtual BOOL ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
public:
	CPen plume[256];

	short m_iNbMax,m_iNo,m_iNb;
	class CBkDoc* *m_pDocument;				//Adresse des documents
	class CBkDoc* GetDocument(void);
	void GetDocument(CBkDoc *p[20]);
	void GetDocumentSansCourant(CBkDoc *p[20]);
	class CBkDoc *GetDocument(short No);
	CBkDoc* CreerNouvelleFenetre(short l,short h);

	imgdes *image;
	//Botes de dialogue non modales
	class CProfilDlg* m_pProfilDlg;
	class CCoteDlg* m_pCoteDlg;
	class CAnnotDlg* m_pAnnotDlg;
	class CEditDlg* m_pEditDlg;
	class CParaDlg* m_pParaDlg;
	class CCalbDlg* m_pCalbDlg;

	//Paramtres_____________________________________
	CStringArray m_sFrTab;	//Position des franges
	short
	m_iType;			//Voir constructeur BkDoc
	float
	m_fIp,				//I'
	m_fIpp,				//I"
	m_fF1,				//f1, flche initiale (mm)
	m_fDf,				//df, flche supplmentaire exerce au point de pousse (mm)
	m_fa,					//position pt appui flche (mm)
	m_fl,					//long. totale de la poutre (mm)
	m_flv,				//long  visualiser (mm)
	m_fLambda,		//long. d'onde (mm)
	m_fHauteur,
	m_fEchz,
	m_fEchxy,
	m_fDecFr;			//dcalage franges
	short m_radioTypeFrange;
	//Franges digitalises au bouton droit___________
	typedef struct
	{
		short x[50],y[50],d[50];				//Positions
	}
	frange;
	frange f;
	float m_fECH;											//1 pixel = 1 mm
	float m_fFx;
	//Image associe
	CString m_sNomFichierImage;
	//Origine franges dans image
	short m_ixOriFr,m_iyOriFr;
	//______________________________________
	BOOL m_OKN;
	//Pointeur sur image associe
	class CBkDoc *m_pDocImage;

	//{{AFX_MSG(CBkApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
