//Paramtres de trac du graphe
const unsigned char
	VIS=0,				INVIS=1,
	NUAGE=0,			BARRE=2,
	COUL_STD=0,		COUL_PART=4,
	NORME=0,			ORTHO_NORME=8,
	NON_SELEC=0,	SELEC=16;

class CGraphe
{
	public:
		CGraphe::CGraphe(class CBkDoc *pDoc,short nbCol);
		~CGraphe(void);
  
  //Attributes
  protected:
	class CBkDoc* m_pDoc;
	class CGeoAna *m_pGeo;
	short m_iNbMax,m_iNbCol;
	public:
	//Jusqu' 8 graphiques diffrents, et jusqu' 4 courbes par graphique
	char COL1[8][4],COL2[8][4];
	CString ABS[8][4],ORD[8][4];
	unsigned char (*m_iVisT)[8][4];
	BOOL
		m_OKAccro;
	short
	 m_iNbC,
	 m_iC1,m_iC2,
	 m_iNo;
	float 
		m_fX,m_fY;
	//Rgressions____________________________________
	unsigned char m_iTypeReg[8][4];		
	BOOL m_OKTrace[8][4];
	double
		m_fa[8][4][8];	//Coefficients

	public:
	//Fonctions de visibilit du graphe
	//Dfinition visibilit
	void DVisG(short graphe,short courbe,short n,unsigned char Visibilite);
	void DVisG(unsigned char Visibilite);

	//Renvoi de la visibilit
	unsigned char RVisG(short graphe,short courbe,short n);

	//Dfinition d'une colonne abs. du graphe________
	void DColXGr(char NoGr,char ColX,CString Abs);
	void DColYGr(char NoGr,char ColX,CString Ord);
	void DColXGr(char NoGr,char Courbe,char ColY,CString Abs);
	void DColYGr(char NoGr,char Courbe,char ColY,CString Ord);

	char RColXGr(char NoGr);
	char RColYGr(char NoGr);
	char RColXGr(char NoGr,char Courbe);
	char RColYGr(char NoGr,char Courbe);

	void Init_Gr(void);
	BOOL AccrocheGraphe(float f_x,float f_y,float ecart);
	void Inc(void);
	void Dec(void);
	BOOL OK(void);
	short C1(void);
	short C2(void);
	short N(void);
	float X(void);
	float Y(void);
	//Slection d'un segment du graphe______________
	short SelecSegment(BOOL bSelec,float f_x,float f_y,float ecart);
	short SelecSegment(BOOL bSelec,short graphe,short courbe,float f_x,float f_y,float ecart);
	BOOL SurSegment(float xp,float yp,short n,short col1,short col2,float ecart);
	//Slection d'une zone du graphe________________
	short AccrocheZone(BOOL bSelect,short graphe,short courbe,float xmi,float ymi,float xma,float yma);
	//Rgressions____________________________________
	BOOL CalculRegres(double (*m_fT)[2],short nb,short ordre,double *Q);

};
