// InterDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "InterDlg.h"
#include "BkDoc.h"
#include "Graphe.h"
#include <math.h>
#include <sys/timeb.h>
#include <locale.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CInterDlg dialog
CInterDlg::CInterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInterDlg)
	m_s = _T("");
	m_s1 = _T("");
	//}}AFX_DATA_INIT
}
void CInterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInterDlg)
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Text(pDX, IDC_STATIC2, m_s1);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CInterDlg, CDialog)
	//{{AFX_MSG_MAP(CInterDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CInterDlg message handlers
BOOL CInterDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i;
	m_pApp=((CBkApp*)AfxGetApp());
	//Recherche vue
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (!m_pApp->m_pDocument[i]!=NULL)
		{
			m_s1.Format("Destination graphe : VUE %d",i);	
			//On sort
			i=m_pApp->m_iNbMax;    
		}
	}
	if ((m_pApp->m_iType&8)==0)	m_s="Modle: Poutre encastre."; else	m_s="Modle: Poutre sur 2 appuis.";
	UpdateData(FALSE);	
	return TRUE;
}
//________________________________________
void CInterDlg::OnOK() 
{
	short i;
	CString s;
	CRect	R,R1;
	CTime t;
	setlocale(LC_TIME,"French");
	t=CTime::GetCurrentTime();   

	UpdateData(TRUE);
	if ((m_pApp->m_iType&8)==8)
	{
		m_pApp->m_iType=8+0;
	}
	else
	{
		m_pApp->m_iType=0+0;
	}
	
	SendMessage(WM_COMMAND,ID_FILE_NEW,0);
	i=m_pApp->m_iNo;
	m_pd=m_pApp->m_pDocument[i];
	//Mise  jour des variables du document

	switch (m_pApp->m_iType&8)
	{
		case 0:
			//Poutre encastre  une extrmit
			m_pd->m_pGr->Init_Gr();
			m_pd->m_iNoGr=0;	//0:Poutre encastre  une extremit
			m_pd->m_pGr->DColXGr(m_pd->m_iNoGr,0,0,"x(mm)");				//PROTOTYPE2, 0:n graphe, 0:n courbe, 0:n colonne
			m_pd->m_pGr->DColYGr(m_pd->m_iNoGr,0,1,"||I2-I1||");
			//Interferences1();
			m_pd->InitAnnotations();
			//s=t.Format("POSITION THEORIQUE DES FRANGES\r\n%A, %d %B %Y - %H:%M:%S");
			s.Format("POSITION THEORIQUE DES FRANGES");
			m_pd->a.s[0]=s;
			m_pd->a.x[0]=4.5;m_pd->a.y[0]=4.5;
			m_pd->a.OK=FALSE;
			//Titre du graphe et de la vue___________________
			//s.Format("(%d) Graphe",m_pd->m_iNo);
			//m_pd->m_sNomFic="Graphe.spe";
			//m_pd->SetTitle(s);
		break;
		case 8:
			//Poutre sur deux appuis
			m_pd->m_pGr->Init_Gr();
			m_pd->m_iNoGr=0;	//0:Poutre encastre  une extremit
			m_pd->m_pGr->DColXGr(m_pd->m_iNoGr,0,0,"x(mm)");				//PROTOTYPE2, 0:n graphe, 0:n courbe, 0:n colonne
			m_pd->m_pGr->DColYGr(m_pd->m_iNoGr,0,1,"||I2-I1||");
			m_pd->InitAnnotations();
			s.Format("POSITION THEORIQUE DES FRANGES");
			m_pd->a.s[0]=s;
			m_pd->a.x[0]=4.5;m_pd->a.y[0]=4.5;
			m_pd->a.OK=FALSE;
		break;
	}
	m_pd->m_sNomFichierImage=m_pApp->m_sNomFichierImage;
	m_pd->m_pDocImage=m_pApp->m_pDocImage;
	m_pd->UpdateAllViews(NULL);
	CDialog::OnOK();
}
//_________________________________________________
void CInterDlg::OnCancel() 
{
	CDialog::OnCancel();
}
