// RegDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "RegDlg.h"
#include "BkDoc.h"
#include "BkView.h"
#include "Graphe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CRegDlg dialog
CRegDlg::CRegDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRegDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRegDlg)
	m_s = _T("");
	m_radioNoCourbe = -1;
	m_sA0 = _T("");
	m_sA1 = _T("");
	m_sA2 = _T("");
	m_sA3 = _T("");
	m_sA4 = _T("");
	m_sA5 = _T("");
	m_sA6 = _T("");
	m_sA7 = _T("");
	m_OKTrace = FALSE;
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_REGRESSION,pParent);
}
void CRegDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegDlg)
	DDX_Control(pDX, IDCALCULER, m_btnCalculer);
	DDX_Control(pDX, IDC_COMBO1, m_ordreDeroul);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Radio(pDX, IDC_COURBE0, m_radioNoCourbe);
	DDX_Text(pDX, IDC_STATIC_A0, m_sA0);
	DDX_Text(pDX, IDC_STATIC_A1, m_sA1);
	DDX_Text(pDX, IDC_STATIC_A2, m_sA2);
	DDX_Text(pDX, IDC_STATIC_A3, m_sA3);
	DDX_Text(pDX, IDC_STATIC_A4, m_sA4);
	DDX_Text(pDX, IDC_STATIC_A5, m_sA5);
	DDX_Text(pDX, IDC_STATIC_A6, m_sA6);
	DDX_Text(pDX, IDC_STATIC_A7, m_sA7);
	DDX_Check(pDX, IDC_TRACE, m_OKTrace);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CRegDlg, CDialog)
	//{{AFX_MSG_MAP(CRegDlg)
	ON_BN_CLICKED(IDCALCULER, OnCalculer)
	ON_BN_CLICKED(IDAJOUTER, OnAjouter)
	ON_BN_CLICKED(IDRETIRER, OnRetirer)
	ON_BN_CLICKED(IDC_COURBE0, OnCourbe0)
	ON_BN_CLICKED(IDC_COURBE1, OnCourbe1)
	ON_BN_CLICKED(IDC_COURBE2, OnCourbe2)
	ON_BN_CLICKED(IDC_COURBE3, OnCourbe3)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_BN_CLICKED(IDC_TRACE, OnTrace)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CRegDlg message handlers
void CRegDlg::PostNcDestroy()
{
	delete this;
}
//_________________________________________________
void CRegDlg::OnCancel() 
{
	m_pDoc->m_iDx=0;
	m_pDoc->m_iDy=0;
	m_pDoc->UpdateAllViews(NULL);
	m_pApp->m_OKReg=FALSE;
	m_pDoc->m_pView->m_pRegDlg=NULL;
	CDialog::OnCancel();
}
//__________________________________________________
void CRegDlg::Fermer(void)
{
	m_pApp->m_OKReg=FALSE;
	m_pDoc->m_pView->m_pRegDlg=NULL;
	CDialog::OnCancel();
}
//__________________________________________________
void CRegDlg::Initialise(void)
{
	short i;
	CString s;
	unsigned char v;
	m_pApp=(CBkApp*)AfxGetApp();
	//N de la fentre active
	m_iNo=m_pApp->m_iNo;
	m_pDoc=m_pApp->m_pDocument[m_iNo];
	//Mode ajout par dfaut
	m_bAjRet=TRUE;
	m_radioNoCourbe=m_pDoc->m_iNoCourbe;
	//Recherche nombre d'lments slectionns
	m_iNbT=0;
	for (i=0;i<m_pDoc->m_iNb;i++)
	{
		v=m_pDoc->m_pGr->RVisG(m_pDoc->m_iNoGr,m_radioNoCourbe,i);
		if ((v&SELEC)==SELEC) m_iNbT++;
	}
	m_s.Format("Courbe %d:\n%d lment(s) slectionn(s)",m_radioNoCourbe,m_iNbT);
	if (m_iNbT==0) m_btnCalculer.EnableWindow(FALSE);
	m_OKTrace=m_pDoc->m_pGr->m_OKTrace[m_pDoc->m_iNoGr][m_radioNoCourbe];
	//Ordre de la rgression linaire
	m_ordreDeroul.AddString("Rgression linaire");
	m_ordreDeroul.AddString("Polynomiale d'ordre 2");
	m_ordreDeroul.AddString("Polynomiale d'ordre 3");
	m_ordreDeroul.AddString("Polynomiale d'ordre 4");
	m_ordreDeroul.AddString("Polynomiale d'ordre 5");
	m_ordreDeroul.AddString("Polynomiale d'ordre 6");
	m_ordreDeroul.AddString("Polynomiale d'ordre 7");
	i=m_ordreDeroul.GetCount();
	if (i>=0)
	{
		m_ordreDeroul.GetLBText(m_pDoc->m_pGr->m_iTypeReg[m_pDoc->m_iNoGr][m_radioNoCourbe],s);
		m_ordreDeroul.SetWindowText(s);	
	}
	EcritCoef();
	if (m_pDoc->m_pGr->RColXGr(m_pDoc->m_iNoGr,0)==-1) GetDlgItem(IDC_COURBE0)->EnableWindow(FALSE);
	if (m_pDoc->m_pGr->RColXGr(m_pDoc->m_iNoGr,1)==-1) GetDlgItem(IDC_COURBE1)->EnableWindow(FALSE);
	if (m_pDoc->m_pGr->RColXGr(m_pDoc->m_iNoGr,2)==-1) GetDlgItem(IDC_COURBE2)->EnableWindow(FALSE);
	if (m_pDoc->m_pGr->RColXGr(m_pDoc->m_iNoGr,3)==-1) GetDlgItem(IDC_COURBE3)->EnableWindow(FALSE);
	if (m_pDoc->m_pGr->RColYGr(m_pDoc->m_iNoGr,0)==-1) GetDlgItem(IDC_COURBE0)->EnableWindow(FALSE);
	if (m_pDoc->m_pGr->RColYGr(m_pDoc->m_iNoGr,1)==-1) GetDlgItem(IDC_COURBE1)->EnableWindow(FALSE);
	if (m_pDoc->m_pGr->RColYGr(m_pDoc->m_iNoGr,2)==-1) GetDlgItem(IDC_COURBE2)->EnableWindow(FALSE);
	if (m_pDoc->m_pGr->RColYGr(m_pDoc->m_iNoGr,3)==-1) GetDlgItem(IDC_COURBE3)->EnableWindow(FALSE);
  UpdateData(FALSE);
}
//__________________________________________________
void CRegDlg::EcritCoef(void)
{
	
	if (m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][0]!=1e10)
	{
		m_sA0.Format("a0:%9.3e",m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][0]);
	}
	else
	{
		//m_sA0="a0=?";
		m_sA0="";
	}
	if (m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][1]!=1e10)
	{
		m_sA1.Format("a1:%9.3e",m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][1]);
	}
	else
	{
		//m_sA1="a1=?";
		m_sA1="";
	}
	if (m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][2]!=1e10)
	{
		m_sA2.Format("a2:%9.3e",m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][2]);
	}
	else
	{
		//m_sA2="a2=?";
		m_sA2="";
	}
	if (m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][3]!=1e10)
	{
		m_sA3.Format("a3:%9.3e",m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][3]);
	}
	else
	{
		//m_sA3="a3=?";
		m_sA3="";
	}
	if (m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][4]!=1e10)
	{
		m_sA4.Format("a4:%9.3e",m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][4]);
	}
	else
	{
		//m_sA4="a4=?";
		m_sA4="";
	}
	if (m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][5]!=1e10)
	{
		m_sA5.Format("a5:%9.3e",m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][5]);
	}
	else
	{
		//m_sA5="a5=?";
		m_sA5="";
	}
	if (m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][6]!=1e10)
	{
		m_sA6.Format("a6:%9.3e",m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][6]);
	}
	else
	{
		//m_sA6="a6=?";
		m_sA6="";
	}
	if (m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][7]!=1e10)
	{
		m_sA7.Format("a7:%9.3e",m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][7]);
	}
	else
	{
		//m_sA7="a7=?";
		m_sA7="";
	}
}
//_________________________________________________
void CRegDlg::OnAjouter() 
{
	m_s="Slectionner les segments  ajouter...";
	m_bAjRet=TRUE;
	UpdateData(FALSE);
}
//_________________________________________________
void CRegDlg::OnRetirer() 
{
	m_s="Slectionner les segments  retirer...";
	m_bAjRet=FALSE;
	UpdateData(FALSE);
}
//__________________________________________________
void CRegDlg::MetAJour(short Nb)
{
	m_iNb=Nb;
	m_iNbT=m_iNbT+m_iNb;
	if (m_iNbT>=2) m_btnCalculer.EnableWindow(TRUE); else m_btnCalculer.EnableWindow(FALSE);
	if (Nb>=0)
	{
		m_s.Format("Courbe %d:\n%d lment(s) slectionn(s)\n%d lment(s) ajout(s)",m_radioNoCourbe,m_iNbT,m_iNb);
	}
	else
	{
		m_s.Format("Courbe %d:\n%d lment(s) slectionn(s)\n%d lment(s) retir(s)",m_radioNoCourbe,m_iNbT,-m_iNb);
	}
	UpdateData(FALSE);
}
//_________________________________________________
void CRegDlg::OnCourbe0() 
{
	Affecte(0);
}
//_________________________________________________
void CRegDlg::OnCourbe1() 
{
	Affecte(1);
}
//_________________________________________________
void CRegDlg::OnCourbe2() 
{
	Affecte(2);
}
//_________________________________________________
void CRegDlg::OnCourbe3() 
{
	Affecte(3);
}
//_________________________________________________
void CRegDlg::Affecte(short n) 
{
	CString s;
	//Ancienne courbe...
	short i=m_radioNoCourbe;
	unsigned char v;
	UpdateData(TRUE);
	m_pDoc->m_pGr->m_OKTrace[m_pDoc->m_iNoGr][i]=m_OKTrace;
	//Nouvelle courbe
	m_OKTrace=m_pDoc->m_pGr->m_OKTrace[m_pDoc->m_iNoGr][m_radioNoCourbe];
	m_pDoc->m_iNoCourbe=n;
	//Recherche nombre d'lments slectionns
	m_iNbT=0;
	for (i=0;i<m_pDoc->m_iNb;i++)
	{
		v=m_pDoc->m_pGr->RVisG(m_pDoc->m_iNoGr,m_radioNoCourbe,i);
		if ((v&SELEC)==SELEC) m_iNbT++;
	}
	m_s.Format("Courbe %d:\n%d lment(s) slectionn(s)\nSlectionner les segments ...",m_radioNoCourbe,m_iNbT);
	if (m_iNbT==0) m_btnCalculer.EnableWindow(FALSE);

	MetAJour(0);
	EcritCoef();

	m_ordreDeroul.GetLBText(m_pDoc->m_pGr->m_iTypeReg[m_pDoc->m_iNoGr][m_radioNoCourbe],s);
	m_ordreDeroul.SetWindowText(s);	

	UpdateData(FALSE);
	m_pDoc->UpdateAllViews(NULL);
}
//_________________________________________________
void CRegDlg::OnSelchangeCombo1() 
{
	UpdateData(TRUE);
	//Dfinition de l'ordre de la rgression
	m_pDoc->m_pGr->m_iTypeReg[m_pDoc->m_iNoGr][m_radioNoCourbe]=m_ordreDeroul.GetCurSel();
}
//_________________________________________________
void CRegDlg::OnCalculer() 
{
	float x,y;
	double 
		Q[8];	//Solution rgression polynomiale jusqu' l'ordre 7
  short
		k,ordre,n,nb,col1,col2;
	unsigned char v;
	BOOL ok;

	UpdateData(TRUE);
	//1.Extraction colonnes du graphique
	col1=m_pDoc->m_pGr->RColXGr(m_pDoc->m_iNoGr,m_radioNoCourbe);
	col2=m_pDoc->m_pGr->RColYGr(m_pDoc->m_iNoGr,m_radioNoCourbe);
	if (col1!=-1 && col2!=-1)
	{
		//2.Dclaration d'un tableau de valeurs
		double (*m_fT)[2];
		m_fT=new double[m_pDoc->m_iNb][2];
		//3. Extraction points slectionns
		nb=0;
		for (n=0;n<m_pDoc->m_iNb;n++)
		{
			v=m_pDoc->m_pGr->RVisG(m_pDoc->m_iNoGr,m_radioNoCourbe,n);
			if ((v&SELEC)==SELEC)
			{
				x=m_pDoc->m_fT[n][col1];
				y=m_pDoc->m_fT[n][col2];
				if (x!=1e10 && y!=1e10)
				{
					m_fT[nb][0]=x;
					m_fT[nb][1]=y;
					nb++;
				}
			}
		}
		//4.Calcul regression
		ordre=m_pDoc->m_pGr->m_iTypeReg[m_pDoc->m_iNoGr][m_radioNoCourbe]+1;
		ok=m_pDoc->m_pGr->CalculRegres(m_fT,nb,ordre,Q);
		//5.Affichage rsultat
		if (!ok)
		{
			m_s="Le calcul de la rgression a chou !";
			m_pDoc->m_pGr->m_OKTrace[m_pDoc->m_iNoGr][m_radioNoCourbe]=FALSE;
			//5.Affectation coefficients
			for (k=0;k<8;k++)
			{
				m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][k]=1e10;
			}	
		}
		else
		{
			for (k=0;k<8;k++)
			{
				m_pDoc->m_pGr->m_fa[m_pDoc->m_iNoGr][m_radioNoCourbe][k]=Q[k];
			}	
			m_s.Format("Calcul rgression d'ordre %d OK !",ordre);
			m_pDoc->m_pGr->m_OKTrace[m_pDoc->m_iNoGr][m_radioNoCourbe]=m_OKTrace;
		}
		//6.Suppression tableau de valeurs
		delete m_fT;
	}
	EcritCoef();
	UpdateData(FALSE);
	m_pDoc->UpdateAllViews(NULL);
}
//_________________________________________________
void CRegDlg::OnTrace() 
{
	//On coche/dcoche l'option trac sur le graphe...
	UpdateData(TRUE);
	m_pDoc->m_pGr->m_OKTrace[m_pDoc->m_iNoGr][m_radioNoCourbe]=m_OKTrace;
	m_pDoc->UpdateAllViews(NULL);
}
