// RegDlg.h : header file
//
/////////////////////////////////////////////////////////////////////////////
// CRegDlg dialog
class CRegDlg : public CDialog
{
// Construction
public:
	CRegDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CRegDlg)
	enum { IDD = IDD_REGRESSION };
	CButton	m_btnCalculer;
	CComboBox	m_ordreDeroul;
	CString	m_s;
	int		m_radioNoCourbe;
	CString	m_sA0;
	CString	m_sA1;
	CString	m_sA2;
	CString	m_sA3;
	CString	m_sA4;
	CString	m_sA5;
	CString	m_sA6;
	CString	m_sA7;
	BOOL	m_OKTrace;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRegDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	class CBkApp* m_pApp;
	class CBkDoc* m_pDoc;
	short m_iNo;
	void PostNcDestroy();
public:
	void Initialise(void);
	void EcritCoef(void);
	void Fermer(void);
	void MetAJour(short Nb);
	void Affecte(short n);
	BOOL m_bAjRet;
	short m_iNb,m_iNbT;

	// Generated message map functions
	//{{AFX_MSG(CRegDlg)
	afx_msg void OnCalculer();
	virtual void OnCancel();
	afx_msg void OnAjouter();
	afx_msg void OnRetirer();
	afx_msg void OnCourbe0();
	afx_msg void OnCourbe1();
	afx_msg void OnCourbe2();
	afx_msg void OnCourbe3();
	afx_msg void OnSelchangeCombo1();
	afx_msg void OnTrace();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
