// BkView.h : interface of the CBkView class
//________________________________________
class CBkView : public CView
{
protected: // create from serialization only
	CBkView();
	DECLARE_DYNCREATE(CBkView)

// Attributes
public:
	CBkDoc* GetDocument();

// Operations
public:
	void FEN_PIX(float xmm,float ymm,short *xp,short *yp);
	void GR_FEN(float x,float y,float *xmm,float *ymm);
	void TAB_GR(float xt,float yt,float *x,float *y);
	void GR_TAB(float x,float y,float *xt,float *yt);
	void FEN_GR(float xmm,float ymm,float *x,float *y);
	void PIX_FEN(short xp,short yp,float *xmm,float *ymm);
protected:
	float
		m_fZoomXmi,m_fZoomXma,m_fZoomYmi,m_fZoomYma;
	short m_iZoom;


	class CBkApp* m_pApp;
	//Edition points du graphe_______________________
	class CEditDlg *m_pEditDlg;
	//Graphiques_____________________________________
	class CGraphe *m_pGr;
	void OnDrawIm(CDC* pDC);
	void OnDrawGr(CDC* pDC);
	void OnDrawXY(CDC* pDC);
	void OnDrawXZ(CDC* pDC);

	void MAJ(void);
	void MAJ_G(float xg,float yg);
	void InitZoom(void);
	void InitSouris(void);
	void PositionFrange(void);
	void OrigineFrange(void);
	void MarqueDePointage(CDC *pDC, short X,short Y,long coul);
	void EcritAnnotations(CDC *pDC);
	short SaveSKL(CString s);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBkView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate();
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBkView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBkView)
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveAs(CCmdUI* pCmdUI);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in BkView.cpp
inline CBkDoc* CBkView::GetDocument()
   { return (CBkDoc*)m_pDocument; }
#endif
//________________________________________
