// CoteDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "CoteDlg.h"
#include "BkDoc.h"
#include "BkView.h"
#include "Vicdefs.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CCoteDlg dialog
CCoteDlg::CCoteDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCoteDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCoteDlg)
	m_s = _T("");
	m_radioNo = -1;
	m_s1 = _T("");
	m_s2 = _T("");
	m_s3 = _T("");
	m_s4 = _T("");
	m_s5 = _T("");
	m_s6 = _T("");
	m_s7 = _T("");
	m_s8 = _T("");
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_COTATION,pParent);
}
void CCoteDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCoteDlg)
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Radio(pDX, IDC_N1, m_radioNo);
	DDX_Text(pDX, IDC_S1, m_s1);
	DDX_Text(pDX, IDC_S2, m_s2);
	DDX_Text(pDX, IDC_S3, m_s3);
	DDX_Text(pDX, IDC_S4, m_s4);
	DDX_Text(pDX, IDC_S5, m_s5);
	DDX_Text(pDX, IDC_S6, m_s6);
	DDX_Text(pDX, IDC_S7, m_s7);
	DDX_Text(pDX, IDC_S8, m_s8);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CCoteDlg, CDialog)
	//{{AFX_MSG_MAP(CCoteDlg)
	ON_BN_CLICKED(IDC_N1, OnN1)
	ON_BN_CLICKED(IDC_N2, OnN2)
	ON_BN_CLICKED(IDC_N3, OnN3)
	ON_BN_CLICKED(IDC_N4, OnN4)
	ON_BN_CLICKED(IDC_N5, OnN5)
	ON_BN_CLICKED(IDC_N6, OnN6)
	ON_BN_CLICKED(IDC_N7, OnN7)
	ON_BN_CLICKED(IDC_N8, OnN8)
	ON_EN_CHANGE(IDC_S1, OnChangeS1)
	ON_EN_CHANGE(IDC_S2, OnChangeS2)
	ON_EN_CHANGE(IDC_S3, OnChangeS3)
	ON_EN_CHANGE(IDC_S4, OnChangeS4)
	ON_EN_CHANGE(IDC_S5, OnChangeS5)
	ON_EN_CHANGE(IDC_S6, OnChangeS6)
	ON_EN_CHANGE(IDC_S7, OnChangeS7)
	ON_EN_CHANGE(IDC_S8, OnChangeS8)
	ON_BN_CLICKED(IDEFFACER, OnEffacer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CCoteDlg message handlers
void CCoteDlg::PostNcDestroy()
{
	delete this;
}
//________________________________________
BOOL CCoteDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	CBkDoc *pDoc=m_pApp->GetDocument();
	short no=pDoc->m_iNo;
	m_s.Format("Digitalisez dans l'image %d...",no);
	m_radioNo=pDoc->c.no;
	MAJ();
	UpdateData(FALSE);	
	return TRUE;
}
//________________________________________
void CCoteDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CCoteDlg::OnCancel() 
{
	m_pApp->m_pCoteDlg=NULL;
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL) pDoc->UpdateAllViews(NULL);
	CDialog::OnCancel();
}
//________________________________________
void CCoteDlg::MAJ(void)
{
	m_pApp=((CBkApp*)AfxGetApp());
	CBkDoc *pDoc=m_pApp->GetDocument();
	m_s1=pDoc->c.s[0];
	m_s2=pDoc->c.s[1];
	m_s3=pDoc->c.s[2];
	m_s4=pDoc->c.s[3];
	m_s5=pDoc->c.s[4];
	m_s6=pDoc->c.s[5];
	m_s7=pDoc->c.s[6];
	m_s8=pDoc->c.s[7];
	//On valide/invalide...
	if (m_radioNo==0) GetDlgItem(IDC_S1)->EnableWindow(TRUE); else GetDlgItem(IDC_S1)->EnableWindow(FALSE);
	if (m_radioNo==1) GetDlgItem(IDC_S2)->EnableWindow(TRUE); else GetDlgItem(IDC_S2)->EnableWindow(FALSE);
	if (m_radioNo==2) GetDlgItem(IDC_S3)->EnableWindow(TRUE); else GetDlgItem(IDC_S3)->EnableWindow(FALSE);
	if (m_radioNo==3) GetDlgItem(IDC_S4)->EnableWindow(TRUE); else GetDlgItem(IDC_S4)->EnableWindow(FALSE);
	if (m_radioNo==4) GetDlgItem(IDC_S5)->EnableWindow(TRUE); else GetDlgItem(IDC_S5)->EnableWindow(FALSE);
	if (m_radioNo==5) GetDlgItem(IDC_S6)->EnableWindow(TRUE); else GetDlgItem(IDC_S6)->EnableWindow(FALSE);
	if (m_radioNo==6) GetDlgItem(IDC_S7)->EnableWindow(TRUE); else GetDlgItem(IDC_S7)->EnableWindow(FALSE);
	if (m_radioNo==7) GetDlgItem(IDC_S8)->EnableWindow(TRUE); else GetDlgItem(IDC_S8)->EnableWindow(FALSE);
	m_s.Format("Digitalisez une cote dans l'image %d...",pDoc->m_iNo);
	UpdateData(FALSE);
}
//________________________________________
void CCoteDlg::Affecte(short x1,short y1,short x2,short y2)
{
	float x,y,l;
	m_pApp=((CBkApp*)AfxGetApp());
	CBkDoc *pDoc=m_pApp->GetDocument();
	m_radioNo=pDoc->c.no;
	m_s.Format("Dans l'image %d: %d,%d,%d,%d",pDoc->m_iNo,x1,y1,x2,y2);

	if (m_radioNo==0) 
	{
		GetDlgItem(IDC_S1)->EnableWindow(TRUE);
		x=1.0*(x2-x1);
		y=1.0*(y2-y1);
		l=pow(pow(x,2)+pow(y,2),0.5);
		if ((pDoc->m_iType&32)==0)
			m_s1.Format("%1.0f",l);
		else
		{
			l=l/m_pApp->m_fECH;
			m_s1.Format("%1.2f",l);
		}
		pDoc->c.s[m_radioNo]=m_s1;
		pDoc->c.x1[m_radioNo]=x1;
		pDoc->c.y1[m_radioNo]=y1;
		pDoc->c.x2[m_radioNo]=x2;
		pDoc->c.y2[m_radioNo]=y2;
	}
	else 
		GetDlgItem(IDC_S1)->EnableWindow(FALSE);
	if (m_radioNo==1)
	{
		GetDlgItem(IDC_S2)->EnableWindow(TRUE);
		x=1.0*(x2-x1);
		y=1.0*(y2-y1);
		l=pow(pow(x,2)+pow(y,2),0.5);
		if ((pDoc->m_iType&32)==0)
			m_s2.Format("%1.0f",l);
		else
		{
			l=l/m_pApp->m_fECH;
			m_s2.Format("%1.2f",l);
		}
		pDoc->c.s[m_radioNo]=m_s2;
		pDoc->c.x1[m_radioNo]=x1;
		pDoc->c.y1[m_radioNo]=y1;
		pDoc->c.x2[m_radioNo]=x2;
		pDoc->c.y2[m_radioNo]=y2;
	}
	else
		GetDlgItem(IDC_S2)->EnableWindow(FALSE);
	if (m_radioNo==2)
	{
		GetDlgItem(IDC_S3)->EnableWindow(TRUE);
		x=1.0*(x2-x1);
		y=1.0*(y2-y1);
		l=pow(pow(x,2)+pow(y,2),0.5);
		if ((pDoc->m_iType&32)==0)
			m_s3.Format("%1.0f",l);
		else
		{
			l=l/m_pApp->m_fECH;
			m_s3.Format("%1.2f",l);
		}
		pDoc->c.s[m_radioNo]=m_s3;
		pDoc->c.x1[m_radioNo]=x1;
		pDoc->c.y1[m_radioNo]=y1;
		pDoc->c.x2[m_radioNo]=x2;
		pDoc->c.y2[m_radioNo]=y2;
	}
	else
		GetDlgItem(IDC_S3)->EnableWindow(FALSE);
	if (m_radioNo==3)
	{
		GetDlgItem(IDC_S4)->EnableWindow(TRUE);
		x=1.0*(x2-x1);
		y=1.0*(y2-y1);
		l=pow(pow(x,2)+pow(y,2),0.5);
		if ((pDoc->m_iType&32)==0)
			m_s4.Format("%1.0f",l);
		else
		{
			l=l/m_pApp->m_fECH;
			m_s4.Format("%1.2f",l);
		}
		pDoc->c.s[m_radioNo]=m_s4;
		pDoc->c.x1[m_radioNo]=x1;
		pDoc->c.y1[m_radioNo]=y1;
		pDoc->c.x2[m_radioNo]=x2;
		pDoc->c.y2[m_radioNo]=y2;
	}
	else
		GetDlgItem(IDC_S4)->EnableWindow(FALSE);
	if (m_radioNo==4)
	{
		GetDlgItem(IDC_S5)->EnableWindow(TRUE);
		x=1.0*(x2-x1);
		y=1.0*(y2-y1);
		l=pow(pow(x,2)+pow(y,2),0.5);
		if ((pDoc->m_iType&32)==0)
			m_s5.Format("%1.0f",l);
		else
		{
			l=l/m_pApp->m_fECH;
			m_s5.Format("%1.2f",l);
		}
		pDoc->c.s[m_radioNo]=m_s5;
		pDoc->c.x1[m_radioNo]=x1;
		pDoc->c.y1[m_radioNo]=y1;
		pDoc->c.x2[m_radioNo]=x2;
		pDoc->c.y2[m_radioNo]=y2;
	}
	else
		GetDlgItem(IDC_S5)->EnableWindow(FALSE);
	if (m_radioNo==5)
	{
		GetDlgItem(IDC_S6)->EnableWindow(TRUE);
		x=1.0*(x2-x1);
		y=1.0*(y2-y1);
		l=pow(pow(x,2)+pow(y,2),0.5);
		if ((pDoc->m_iType&32)==0)
			m_s6.Format("%1.0f",l);
		else
		{
			l=l/m_pApp->m_fECH;
			m_s6.Format("%1.2f",l);
		}
		pDoc->c.s[m_radioNo]=m_s6;
		pDoc->c.x1[m_radioNo]=x1;
		pDoc->c.y1[m_radioNo]=y1;
		pDoc->c.x2[m_radioNo]=x2;
		pDoc->c.y2[m_radioNo]=y2;
	}
	else
		GetDlgItem(IDC_S6)->EnableWindow(FALSE);
	if (m_radioNo==6)
	{
		GetDlgItem(IDC_S7)->EnableWindow(TRUE);
		x=1.0*(x2-x1);
		y=1.0*(y2-y1);
		l=pow(pow(x,2)+pow(y,2),0.5);
		if ((pDoc->m_iType&32)==0)
			m_s7.Format("%1.0f",l);
		else
		{
			l=l/m_pApp->m_fECH;
			m_s7.Format("%1.2f",l);
		}
		pDoc->c.s[m_radioNo]=m_s7;
		pDoc->c.x1[m_radioNo]=x1;
		pDoc->c.y1[m_radioNo]=y1;
		pDoc->c.x2[m_radioNo]=x2;
		pDoc->c.y2[m_radioNo]=y2;
	}
	else
		GetDlgItem(IDC_S7)->EnableWindow(FALSE);
	if (m_radioNo==7)
	{
		GetDlgItem(IDC_S8)->EnableWindow(TRUE);
		x=1.0*(x2-x1);
		y=1.0*(y2-y1);
		l=pow(pow(x,2)+pow(y,2),0.5);
		if ((pDoc->m_iType&32)==0)
			m_s8.Format("%1.0f",l);
		else
		{
			l=l/m_pApp->m_fECH;
			m_s8.Format("%1.2f",l);
		}
		pDoc->c.s[m_radioNo]=m_s8;
		pDoc->c.x1[m_radioNo]=x1;
		pDoc->c.y1[m_radioNo]=y1;
		pDoc->c.x2[m_radioNo]=x2;
		pDoc->c.y2[m_radioNo]=y2;
	}
	else
		GetDlgItem(IDC_S8)->EnableWindow(FALSE);


	UpdateData(FALSE);
}
//________________________________________
void CCoteDlg::OnN1() 
{
	m_radioNo=0;
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.no=m_radioNo;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnN2() 
{
	m_radioNo=1;
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.no=m_radioNo;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnN3() 
{
	m_radioNo=2;
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.no=m_radioNo;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnN4() 
{
	m_radioNo=3;
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.no=m_radioNo;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnN5() 
{
	m_radioNo=4;
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.no=m_radioNo;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnN6() 
{
	m_radioNo=5;
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.no=m_radioNo;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnN7() 
{
	m_radioNo=6;
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.no=m_radioNo;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnN8() 
{
	m_radioNo=7;
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.no=m_radioNo;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnChangeS1() 
{
	UpdateData(TRUE);
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.s[0]=m_s1;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnChangeS2() 
{
	UpdateData(TRUE);
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.s[1]=m_s2;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnChangeS3() 
{
	UpdateData(TRUE);
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.s[2]=m_s3;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnChangeS4() 
{
	UpdateData(TRUE);
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.s[3]=m_s4;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnChangeS5() 
{
	UpdateData(TRUE);
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.s[4]=m_s5;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnChangeS6() 
{
	UpdateData(TRUE);
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.s[5]=m_s6;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnChangeS7() 
{
	UpdateData(TRUE);
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.s[6]=m_s7;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnChangeS8() 
{
	UpdateData(TRUE);
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		pDoc->c.s[7]=m_s8;
		MAJ();
	}	
}
//________________________________________
void CCoteDlg::OnEffacer() 
{
	short i;
	CBkDoc *pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		for (i=0;i<8;i++)
		{
			pDoc->c.s[i]="";
		}
		MAJ();
		pDoc->UpdateAllViews(NULL);
	}	
}
