// EditDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "EditDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CEditDlg dialog
CEditDlg::CEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditDlg)
	m_s = _T("");
	m_s00 = _T("");
	m_s01 = _T("");
	m_s02 = _T("");
	m_s03 = _T("");
	m_s04 = _T("");
	m_s10 = _T("");
	m_s11 = _T("");
	m_s12 = _T("");
	m_s13 = _T("");
	m_s14 = _T("");
	m_s20 = _T("");
	m_s21 = _T("");
	m_s22 = _T("");
	m_s23 = _T("");
	m_s24 = _T("");
	m_iL0 = 0;
	m_iL1 = 0;
	m_iL2 = 0;
	m_iNoL = 0;
	//}}AFX_DATA_INIT
	Create(IDD_EDIT,pParent);
}
void CEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditDlg)
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Text(pDX, IDC_EDIT00, m_s00);
	DDX_Text(pDX, IDC_EDIT01, m_s01);
	DDX_Text(pDX, IDC_EDIT02, m_s02);
	DDX_Text(pDX, IDC_EDIT03, m_s03);
	DDX_Text(pDX, IDC_EDIT04, m_s04);
	DDX_Text(pDX, IDC_EDIT10, m_s10);
	DDX_Text(pDX, IDC_EDIT11, m_s11);
	DDX_Text(pDX, IDC_EDIT12, m_s12);
	DDX_Text(pDX, IDC_EDIT13, m_s13);
	DDX_Text(pDX, IDC_EDIT14, m_s14);
	DDX_Text(pDX, IDC_EDIT20, m_s20);
	DDX_Text(pDX, IDC_EDIT21, m_s21);
	DDX_Text(pDX, IDC_EDIT22, m_s22);
	DDX_Text(pDX, IDC_EDIT23, m_s23);
	DDX_Text(pDX, IDC_EDIT24, m_s24);
	DDX_Text(pDX, IDC_L0, m_iL0);
	DDX_Text(pDX, IDC_L1, m_iL1);
	DDX_Text(pDX, IDC_L2, m_iL2);
	DDX_Text(pDX, IDC_NOLIG, m_iNoL);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CEditDlg, CDialog)
	//{{AFX_MSG_MAP(CEditDlg)
	ON_BN_CLICKED(IDSUIVANT, OnSuivant)
	ON_BN_CLICKED(IDPRECEDANT, OnPrecedant)
	ON_BN_CLICKED(IDALLERLIGNE, OnAllerligne)
	ON_BN_CLICKED(IDEFFACER, OnEffacer)
	ON_BN_CLICKED(IDMEMORISER, OnMemoriser)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CEditDlg message handlers
void CEditDlg::PostNcDestroy()
{
	delete this;
}
//_________________________________________________
void CEditDlg::OnOK() 
{
	//CDialog::OnOK();
}
//_________________________________________________
BOOL CEditDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	//N de la fentre active
	m_iNo=m_pApp->m_iNo;
	m_pDoc=m_pApp->m_pDocument[m_iNo];
	m_s.Format("(%d)",m_iNo);

	m_iNoL=0;AfficherLigne(m_iNoL);

	UpdateData(FALSE);
	return TRUE;
}
//_________________________________________________
void CEditDlg::OnCancel() 
{
	m_pApp->m_pEditDlg=NULL;
	CDialog::OnCancel();
}
//__________________________________________________
void CEditDlg::Fermer(void)
{
	m_pApp->m_pEditDlg=NULL;
	CDialog::OnCancel();
}
//__________________________________________________
void CEditDlg::AfficherLigne(short n)
{
	float r;
	if (n<0) n=0;
	if (n>m_pDoc->m_iNbMax-1) n=m_pDoc->m_iNbMax-1;

	m_iNoL=n;
	//Ligne courante
	m_iL1=n;
	r=m_pDoc->m_fT[m_iL1][0];if (r==1e10) m_s10=""; else	m_s10.Format("%1.3f",r);
	r=m_pDoc->m_fT[m_iL1][1];if (r==1e10) m_s11=""; else	m_s11.Format("%1.3f",r);
	r=m_pDoc->m_fT[m_iL1][2];if (r==1e10) m_s12=""; else	m_s12.Format("%1.3f",r);
	r=m_pDoc->m_fT[m_iL1][3];if (r==1e10) m_s13=""; else	m_s13.Format("%1.3f",r);
	r=m_pDoc->m_fT[m_iL1][4];if (r==1e10) m_s14=""; else	m_s14.Format("%1.3f",r);
	//Ligne avant
	m_iL0=n-1;if (m_iL0<0) m_iL0=m_pDoc->m_iNbMax-1;
	r=m_pDoc->m_fT[m_iL0][0];if (r==1e10) m_s00=""; else	m_s00.Format("%1.3f",r);
	r=m_pDoc->m_fT[m_iL0][1];if (r==1e10) m_s01=""; else	m_s01.Format("%1.3f",r);
	r=m_pDoc->m_fT[m_iL0][2];if (r==1e10) m_s02=""; else	m_s02.Format("%1.3f",r);
	r=m_pDoc->m_fT[m_iL0][3];if (r==1e10) m_s03=""; else	m_s03.Format("%1.3f",r);
	r=m_pDoc->m_fT[m_iL0][4];if (r==1e10) m_s04=""; else	m_s04.Format("%1.3f",r);
	//Ligne aprs
	m_iL2=n+1;if (m_iL2>m_pDoc->m_iNbMax-1) m_iL2=0;
	r=m_pDoc->m_fT[m_iL2][0];if (r==1e10) m_s20=""; else	m_s20.Format("%1.3f",r);
	r=m_pDoc->m_fT[m_iL2][1];if (r==1e10) m_s21=""; else	m_s21.Format("%1.3f",r);
	r=m_pDoc->m_fT[m_iL2][2];if (r==1e10) m_s22=""; else	m_s22.Format("%1.3f",r);
	r=m_pDoc->m_fT[m_iL2][3];if (r==1e10) m_s23=""; else	m_s23.Format("%1.3f",r);
	r=m_pDoc->m_fT[m_iL2][4];if (r==1e10) m_s24=""; else	m_s24.Format("%1.3f",r);
	UpdateData(FALSE);
}
//_________________________________________________
void CEditDlg::OnSuivant() 
{
	//Ligne suivante dans le tableau
	m_iNoL++;
	//if (m_iNoL>=m_pDoc->m_iNb) m_iNoL=0;
	if (m_iNoL>=m_pDoc->m_iNbMax) m_iNoL=0;
	AfficherLigne(m_iNoL);
}
//_________________________________________________
void CEditDlg::OnPrecedant() 
{
	//Ligne prcdante dans le tableau
	m_iNoL--;
	//if (m_iNoL<0) m_iNoL=m_pDoc->m_iNb-1;
	if (m_iNoL<0) m_iNoL=m_pDoc->m_iNbMax-1;
	AfficherLigne(m_iNoL);
}
//_________________________________________________
void CEditDlg::OnAllerligne() 
{
	//Aller  la ligne demande
	UpdateData(TRUE);
	if(m_iNoL<0) m_iNoL=0;
	if (m_iNoL>m_pDoc->m_iNbMax-1) m_iNoL=m_pDoc->m_iNbMax-1;
	m_iNoL=m_iNoL;AfficherLigne(m_iNoL);
}
//_________________________________________________
void CEditDlg::OnEffacer() 
{
	UpdateData(TRUE);
	if(m_iNoL>=0 && m_iNoL<=m_pDoc->m_iNbMax-1)
	{
		//Effacer ligne courante
		for (short i=0;i<5;i++)
		{
			m_pDoc->m_fT[m_iNoL][i]=1e10;
		}
		AfficherLigne(m_iNoL);
		m_pDoc->UpdateAllViews(NULL);
	}
}
//_________________________________________________
void CEditDlg::OnMemoriser() 
{
	//Mmoriser les valeurs de la ligne dans le tableau
	UpdateData(TRUE);
	int k;
	float r;
	k=sscanf(m_s10,"%f",&r);if (k==1) m_pDoc->m_fT[m_iNoL][0]=r; else m_pDoc->m_fT[m_iNoL][0]=1e10;
	k=sscanf(m_s11,"%f",&r);if (k==1) m_pDoc->m_fT[m_iNoL][1]=r; else m_pDoc->m_fT[m_iNoL][1]=1e10;
	k=sscanf(m_s12,"%f",&r);if (k==1) m_pDoc->m_fT[m_iNoL][2]=r; else m_pDoc->m_fT[m_iNoL][2]=1e10;
	k=sscanf(m_s13,"%f",&r);if (k==1) m_pDoc->m_fT[m_iNoL][3]=r; else m_pDoc->m_fT[m_iNoL][3]=1e10;
	k=sscanf(m_s14,"%f",&r);if (k==1) m_pDoc->m_fT[m_iNoL][4]=r; else m_pDoc->m_fT[m_iNoL][4]=1e10;
	AfficherLigne(m_iNoL);
	m_pDoc->UpdateAllViews(NULL);
}
