// MainFrm.h : interface of the CMainFrame class
//________________________________________
class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

// Attributes
public:
protected:
	class CBkApp* m_pApp;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg void OnUpdatePage(CCmdUI *pCmdUI);
	afx_msg void OnUpdatePage1(CCmdUI *pCmdUI);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnImageProfils();
	afx_msg void OnUpdateImageProfils(CCmdUI* pCmdUI);
	afx_msg void OnUpdateImageCotation(CCmdUI* pCmdUI);
	afx_msg void OnImageCotation();
	afx_msg void OnUpdateAnnotation(CCmdUI* pCmdUI);
	afx_msg void OnAnnotation();
	afx_msg void OnUpdateParametres(CCmdUI* pCmdUI);
	afx_msg void OnParametres();
	afx_msg void OnUpdateDeformeeXz(CCmdUI* pCmdUI);
	afx_msg void OnDeformeeXz();
	afx_msg void OnUpdateFrangesXy(CCmdUI* pCmdUI);
	afx_msg void OnFrangesXy();
	afx_msg void OnGraphe();
	afx_msg void OnUpdateGraphe(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCalibration(CCmdUI* pCmdUI);
	afx_msg void OnCalibration();
	afx_msg void OnUpdateImageMiroir(CCmdUI* pCmdUI);
	afx_msg void OnImageMiroir();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//________________________________________
