// ParaDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "ParaDlg.h"
#include "BkDoc.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CParaDlg dialog
CParaDlg::CParaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CParaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CParaDlg)
	m_fEchz = 0.0f;
	m_fIp = 0.0f;
	m_fIpp = 0.0f;
	m_fLambda = 0.0f;
	m_fF1 = 0.0f;
	m_fDf = 0.0f;
	m_s1 = _T("");
	m_s2 = _T("");
	m_s = _T("");
	m_fDecFr = 0.0f;
	m_radioTypeFrange = -1;
	m_fl = 0.0f;
	m_fa = 0.0f;
	m_flv = 0.0f;
	m_s99 = _T("");
	m_radioModele = -1;
	m_sPos = _T("");
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_PARA,pParent);
}
void CParaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CParaDlg)
	DDX_Control(pDX, IDSUPTOUT, m_btnSupTout);
	DDX_Control(pDX, IDSUPPRIMER, m_btnSupprimer);
	DDX_Control(pDX, IDC_LISTE, m_listePos);
	DDX_Text(pDX, IDC_ECHZ, m_fEchz);
	DDX_Text(pDX, IDC_I, m_fIp);
	DDX_Text(pDX, IDC_I2, m_fIpp);
	DDX_Text(pDX, IDC_LAMBDA, m_fLambda);
	DDX_Text(pDX, IDC_F1, m_fF1);
	DDX_Text(pDX, IDC_DF, m_fDf);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	DDX_Text(pDX, IDC_STATIC2, m_s2);
	DDX_Text(pDX, IDC_STATIC_TEXTE1, m_s);
	DDX_Text(pDX, IDC_DEC, m_fDecFr);
	DDX_Radio(pDX, IDC_RADIOFR, m_radioTypeFrange);
	DDX_Text(pDX, IDC_LONG1, m_fl);
	DDX_Text(pDX, IDC_LONG2, m_fa);
	DDX_Text(pDX, IDC_LONG5, m_flv);
	DDX_Text(pDX, IDC_STATIC99, m_s99);
	DDX_Radio(pDX, IDC_MODELE1, m_radioModele);
	DDX_Text(pDX, IDC_POS, m_sPos);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CParaDlg, CDialog)
	//{{AFX_MSG_MAP(CParaDlg)
	ON_BN_CLICKED(IDSUPPRIMER, OnSupprimer)
	ON_BN_CLICKED(IDSUPTOUT, OnSuptout)
	ON_EN_CHANGE(IDC_POS, OnChangePos)
	ON_BN_CLICKED(IDAPPLIQUER, OnAppliquer)
	ON_BN_CLICKED(IDPLUS, OnPlus)
	ON_BN_CLICKED(IDMOINS, OnMoins)
	ON_BN_CLICKED(IDMOINS2, OnMoins2)
	ON_BN_CLICKED(IDPLUS2, OnPlus2)
	ON_BN_CLICKED(IDC_MODELE1, OnModele1)
	ON_BN_CLICKED(IDC_MODELE2, OnModele2)
	ON_BN_CLICKED(IDDEFINIR, OnDefinir)
	ON_LBN_SELCHANGE(IDC_LISTE, OnSelchangeListe)
	ON_BN_CLICKED(IDPLUS3, OnPlus3)
	ON_BN_CLICKED(IDMOINS3, OnMoins3)
	ON_BN_CLICKED(IDPLUS4, OnPlus4)
	ON_BN_CLICKED(IDMOINS4, OnMoins4)
	ON_BN_CLICKED(IDPLUS5, OnPlus5)
	ON_BN_CLICKED(IDMOINS5, OnMoins5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CParaDlg message handlers
void CParaDlg::PostNcDestroy()
{
	delete this;
}
//________________________________________
BOOL CParaDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_ps=(CBkDoc*)pChild->GetActiveDocument(); else m_ps=NULL;

	CBkDoc *pDoc1;
	BOOL ok=FALSE;
	short i;
	//Association automatique de l'image
	for (i=0;i<20;i++)
	{
		pDoc1=m_pApp->GetDocument(i);
		if (pDoc1!=NULL)
		{
			if (pDoc1->m_sNomFichierImage.GetLength()==0 && (m_ps->m_iType&1)==1 && m_ps->m_sNomFichierImage.GetLength()!=0)
			{
				pDoc1->m_sNomFichierImage=m_ps->m_sNomFic;
				m_pApp->m_sNomFichierImage=m_ps->m_sNomFic;
				pDoc1->m_pDocImage=m_pApp->m_pDocImage=m_ps;
				pDoc1->UpdateAllViews(NULL);
				ok=TRUE;
			}
		}
	}
	if (ok) m_ps->m_sNomFichierImage=m_ps->m_sNomFic;
	Message();
	MAJ(m_ps);
	return TRUE;
}
//________________________________________
void CParaDlg::Appliquer(CBkDoc *pDoc) 
{
	short i;
	CString s;

	if (pDoc!=NULL)
	{
		switch (m_radioModele)
		{
			case 0://2 appuis
				GetDlgItem(IDC_STATIC98)->SetWindowText("Poutre sur 2 appuis");
				if ((pDoc->m_iType&8)!=8) pDoc->m_iType=pDoc->m_iType+8;
				m_s1="Long. &l entre appuis (mm) :";
				m_s2="&Dist. &a appui/flche (mm) :";
			break;
			case 1://Encastre
				GetDlgItem(IDC_STATIC98)->SetWindowText("Poutre encastre");
				if ((pDoc->m_iType&8)==8) pDoc->m_iType=pDoc->m_iType-8;
				m_s1="Long. &l poutre (mm) :";
				m_s2="&Dist. &a encast./flche (mm) :";
			break;
		}
		UpdateData(FALSE);
		pDoc->m_fa=m_fa;	
		pDoc->m_fIp=m_fIp;	
		pDoc->m_fIpp=m_fIpp;	
		pDoc->m_fF1=m_fF1;	
		pDoc->m_fDf=m_fDf/1e3;	
		pDoc->m_fLambda=m_fLambda/1e6;			
		pDoc->m_fl=m_fl;	
		pDoc->m_flv=m_flv;	
		pDoc->m_fEchz=m_fEchz;
		pDoc->m_fDecFr=m_fDecFr;	
		pDoc->m_radioTypeFrange=m_radioTypeFrange;

		pDoc->m_sFrTab.RemoveAll();
		for (i=0;i<m_listePos.GetCount();i++)
		{                             
			m_listePos.GetText(i,s);	
			pDoc->m_sFrTab.Add(s);
		}
		pDoc->MAJ_Para_Doc_App();
		pDoc->UpdateAllViews(NULL);
	}
}
//________________________________________
void CParaDlg::OnAppliquer() 
{
	CString s,s1;
	short i;
	class CBkDoc *pDoc,*pDoc1;

	UpdateData(TRUE);
	TesterVariables();
	UpdateData(FALSE);

	//CString z;z.Format("%f",m_fDf);AfxMessageBox(z);

	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	if (pDoc!=NULL) 
	{
		if (m_listePos.GetCount()==0)
		{
			m_btnSupTout.EnableWindow(FALSE);
			m_btnSupprimer.EnableWindow(FALSE);
		}
		else
		{
			m_btnSupTout.EnableWindow(TRUE);
			m_btnSupprimer.EnableWindow(TRUE);
		}

		Appliquer(pDoc);
		//m_pApp->m_iType=pDoc->m_iType;
		//Mise  jour de toutes les fentres associes
		for (i=0;i<20;i++)
		{
			pDoc1=m_pApp->GetDocument(i);
			if (pDoc1!=NULL) 
			{
				s=pDoc->m_sNomFichierImage;
				s.MakeUpper();
				s1=pDoc1->m_sNomFichierImage;
				s1.MakeUpper();
				if (s.Find(s1)!=-1 && s1.GetLength()!=0)
				{
					Appliquer(pDoc1);
					//CString z;z.Format("%d",pDoc1->m_iNo);AfxMessageBox(z);
				}
			}
		}
	}
}
//________________________________________
void CParaDlg::OnCancel() 
{
	m_pApp->m_pParaDlg=NULL;
	CDialog::OnCancel();
}
//________________________________________
void CParaDlg::Fermer(void)
{
	OnCancel();
}
//________________________________________
void CParaDlg::Affecte1(CString s)
{
	if (s.GetLength()!=0)
		m_s99.Format("(%d) %s",m_pApp->m_pDocImage->m_iNo,s);
	else
		m_s99="";
	UpdateData(FALSE);	
}
//________________________________________
void CParaDlg::Affecte(short x1,short y1,short x2,short y2) 
{
	short i,j;
	float l,r,r1;
	CString s,s1;
	class CBkDoc *pDoc,*pDoc1;

	pDoc=m_pApp->GetDocument();//Image
	if (pDoc!=NULL && (pDoc->m_iType&32)==32 && (pDoc->m_iType&1)==1)//Image calibre
	{

		//m_pApp->m_pDocImage=pDoc;


		r=1.0*(x2-x1);
		r1=1.0*(y2-y1);
		l=pow(pow(r,2)+pow(r1,2),0.5);
		m_sPos.Format("%1.0f",l/pDoc->m_fECH);
		UpdateData(FALSE);

		//Mmorisation position pour affichage dans toutes les fentres associes
		for (j=0;j<20;j++)//20 fentres maxi
		{
			pDoc1=m_pApp->GetDocument(j);
			if (pDoc1!=NULL) 
			{
				pDoc1->m_pDocImage=pDoc;
				s=pDoc->m_sNomFichierImage;
				s.MakeUpper();
				s1=pDoc1->m_sNomFichierImage;
				s1.MakeUpper();
				if (s.Find(s1)!=-1 && s1.GetLength()!=0)
				{
					for (i=0;i<50;i++)//50 franges maxi
					{
						if (pDoc1->f.x[i]==-1)
						{
							pDoc1->f.x[i]=x2;
							pDoc1->f.y[i]=y2;
							pDoc1->f.d[i]=(short)(l/pDoc->m_fECH);
							i=50;//On sort
						}
					}
				}
			}
		}
		OnDefinir();
	}
}
//________________________________________
void CParaDlg::OnDefinir() 
{
	//Ajout d'une frange --> AJOUT MANUEL SUPPRIME LE 19/07/07 car on ne peut pas dssiner la position dans l'image
	//Bouton bote de dialogue coch INVISIBLE
	CString s;          
	int i;
	float r,r1;
	BOOL OK;

  UpdateData(TRUE);
	TesterVariables();
  UpdateData(FALSE);

	//Formatage: float, compris entre 0 et m_fLong
	i=sscanf(m_sPos,"%f",&r);
	if (i==1)
	{   
		if (r>=0 && r<=m_fl)
		{
			//Recherche si lment dj dans liste
			OK=FALSE;
			for (i=0;i<m_listePos.GetCount();i++)
			{                             
				m_listePos.GetText(i,s);	
				//Conversion vers float
				sscanf(s,"%f",&r1);
				if (fabs(r-r1)<0.1) 
				{
					//AfxMessageBox("Elment dj dans la liste!");
					OK=TRUE;
				}
			}		  
			if (!OK)
			{
				//On ajoute en insrant  la bonne position
				i=0;
				do
				{
					if (m_listePos.GetCount()>0)
					{

						m_listePos.GetText(i,s);	
						//Conversion vers float
						sscanf(s,"%f",&r1);
					}
					i++;
				}
				while(i<m_listePos.GetCount() && r>r1);  
				if (r>r1) 
					//A la fin
					m_listePos.AddString(m_sPos);
				else        
					//Intercaler
					m_listePos.InsertString(i-1,m_sPos);
			}
		}
		else	
			AfxMessageBox("Valeur suprieure  la\nlongueur de la poutre !");
	}
	else
		//AfxMessageBox("Valeur numrique incorrecte !")
		;

	Message();
	OnAppliquer();
}
//________________________________________
void CParaDlg::OnSupprimer() 
{
	class CBkDoc *pDoc,*pDoc1;
	int i,j,k,l,n;
	CString s,s1;

	pDoc=m_pApp->GetDocument();
	i=m_listePos.GetCount();  
	if (i>0)
	{  
		i=m_listePos.GetCurSel();
		if (i>=0)
		{
			m_listePos.GetText(i,s);
			m_listePos.DeleteString(i);
			j=sscanf(s,"%d",&n);
			if (pDoc!=NULL && j==1)
			{
				//Suppression dans toutes les fentres associes
				for (l=0;l<20;l++)//20 fentres maxi
				{
					pDoc1=m_pApp->GetDocument(l);
					if (pDoc1!=NULL) 
					{
						s=pDoc->m_sNomFichierImage;
						s.MakeUpper();
						s1=pDoc1->m_sNomFichierImage;
						s1.MakeUpper();
						if (s.Find(s1)!=-1 && s1.GetLength()!=0)
						{
							//CString z;z.Format("%d,%s",n,pDoc1->m_sNomFic);AfxMessageBox(z);
							for (k=0;k<50;k++)
							{
								//CString z;z.Format("%s,%d,%d",pDoc1->m_sNomFic,n,pDoc1->f.d[k]);AfxMessageBox(z);
								if (abs(pDoc1->f.d[k]-n)<=1)
								{

									pDoc1->f.x[k]=-1;
									pDoc1->f.y[k]=-1;
									pDoc1->f.d[k]=-1;
									k=50;//On sort
								}
							}
						}
						pDoc1->UpdateAllViews(NULL);
					}
				}
			}
			//On se replace sur la premire valeur
			m_listePos.GetText(0,m_sPos);	
			UpdateData(FALSE);
  	}
  }
	OnAppliquer();
}
//________________________________________
void CParaDlg::OnSuptout() 
{
	class CBkDoc *pDoc,*pDoc1;
	short l,k;
	CString s1,s;
	pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		//Suppression dans toutes les fentres associes
		for (l=0;l<20;l++)//20 fentres maxi
		{
			pDoc1=m_pApp->GetDocument(l);
			if (pDoc1!=NULL) 
			{
				s=pDoc->m_sNomFichierImage;
				s.MakeUpper();
				s1=pDoc1->m_sNomFichierImage;
				s1.MakeUpper();
				if (s.Find(s1)!=-1 && s1.GetLength()!=0)
				{
					for (k=0;k<50;k++)
					{
						pDoc1->f.x[k]=-1;
						pDoc1->f.y[k]=-1;
						pDoc1->f.d[k]=-1;
					}
				}
				pDoc->UpdateAllViews(NULL);
			}
		}
	}		 
	m_listePos.ResetContent();
	m_sPos="";	
	m_btnSupTout.EnableWindow(FALSE);
	m_btnSupprimer.EnableWindow(FALSE);
	UpdateData(FALSE);
	OnAppliquer();
}
//________________________________________
void CParaDlg::OnSelchangeListe() 
{
	//Afficher cette position dans la zone de texte
	int i;
	CString s;
	i=m_listePos.GetCurSel(); 
	if (i>=0)
	{
		m_listePos.GetText(i,m_sPos);	
		UpdateData(FALSE);
	}
}
//________________________________________
void CParaDlg::OnChangePos() 
{
	//Activation frange dans listbox
	CString s;          
	int i;
	float r,r1;
  UpdateData(TRUE);
	//Formatage: float, compris entre 0 et m_fl
	i=sscanf(m_sPos,"%f",&r);
	if (i==1)
	{   
		if (r>=0 && r<=m_pApp->m_fl)
		{
			//Recherche si lment dj dans liste
			for (i=0;i<m_listePos.GetCount();i++)
			{                             
				m_listePos.GetText(i,s);	
				//Conversion vers float
				sscanf(s,"%f",&r1);
				if (fabs(r-r1)<0.1) 
				{
					//Activer	la frange i 
					m_listePos.SetCurSel(i);
				} 
			}
		}
	}			
}
//________________________________________
void CParaDlg::OnOK() 
{
	OnDefinir();
	//CDialog::OnOK();
}
//________________________________________
void CParaDlg::Message(void) 
{
	class CBkDoc* pDoc;
	short i,n;
	pDoc=m_pApp->GetDocument();
	if (pDoc!=NULL)
	{
		n=0;
		for (i=0;i<50;i++)//50 franges maxi
		{
			if (pDoc->f.x[i]!=-1)
			{
				n++;
			}
		}
		if (n==0)
		{
			m_btnSupTout.EnableWindow(FALSE);
			m_btnSupprimer.EnableWindow(FALSE);
		}
		else
		{
			m_btnSupTout.EnableWindow(TRUE);
			m_btnSupprimer.EnableWindow(TRUE);
		}
		
		if (!(pDoc->m_iType&1))
		{
			if (pDoc->m_sNomFichierImage.GetLength()==0)
				m_s.Format("Ouvrir une image  associer au graphe et dfinir la position des franges...");
			else
			{
				if (n>=50) 
					m_s.Format("Nb maxi de 50 franges atteint !");
				else
					m_s.Format("Spcifier l'origine et la position des franges avec le BD de la souris dans %s...",pDoc->m_sNomFichierImage);
			}
		}
		else
		{
			if ((pDoc->m_iType&32)==32)
			{
				if (1.0*pDoc->m_iH/pDoc->m_fECH>300.0)
					m_s.Format("La calibration de l'image associe semble incorrecte...");
				else
				{
					if (pDoc->m_sNomFichierImage.GetLength()==0)
						m_s.Format ("Ouvrir une image  associer au graphe et dfinir la position des franges...");
					else
					{
						if (n>=50) 
							m_s.Format("Nb maxi de 50 franges atteint !");
						else
							m_s.Format("Spcifier l'origine et la position des franges avec le BD de la souris dans %s...",pDoc->m_sNomFichierImage);
					}
				}
			}
			else
			{
				m_s.Format("Image %s non calibre ...\nFaire Image/Calibration.",pDoc->m_sNomFichierImage);
			}
		}
		if (pDoc->m_sNomFichierImage.GetLength()!=0)
			m_s99.Format("(%d): %s",pDoc->m_iNo,pDoc->m_sNomFichierImage);
		else
			m_s99.Format("(%d): ?",pDoc->m_iNo);
	}
	else
	{
		m_s="";
	}
	UpdateData(FALSE);	
}
//________________________________________
void CParaDlg::TesterVariables(void) 
{
	if (m_flv<50) m_flv=50;
	if (m_flv>300) m_flv=300;
	if (m_fl<50) m_fl=50;
	if (m_fl>300) m_fl=300;

	if (m_fIp<0 || m_fIp>100) m_fIp=1;
	if (m_fIpp<0 || m_fIpp>100) m_fIpp=1;
	if (m_fF1<0) m_fF1=0;
	if (m_fF1>50) m_fF1=50;
	if (m_fDf<0.1) m_fDf=0.1;
	if (m_fDf>50) m_fDf=50;
	if (m_fLambda<100 || m_fLambda>900) m_fLambda=632.8;

		if(m_radioModele==0)
		{
			//2 appuis
			if (m_fa<10) m_fa=10;
			if (m_fa>m_fl-10) m_fa=m_fl-10;
		}
		else
		{
			//Encastrement
			if (m_fa<10) m_fa=10;
			if (m_fa>m_fl) m_fa=m_fl;
		}
	if (m_fEchz<=0) m_fEchz=0;	
	if (m_fEchz>=15000) m_fEchz=15000;	

}
//________________________________________
void CParaDlg::OnPlus() 
{
	UpdateData(TRUE);
	m_fDf=m_fDf+0.1;	
	UpdateData(FALSE);
	OnAppliquer();
}
//________________________________________
void CParaDlg::OnMoins() 
{
	UpdateData(TRUE);
	m_fDf=m_fDf-0.1;	
	UpdateData(FALSE);
	OnAppliquer();
}
//________________________________________
void CParaDlg::OnMoins2() 
{
	UpdateData(TRUE);
	m_fa=m_fa-1.0;	
	UpdateData(FALSE);
	OnAppliquer();
}
//________________________________________
void CParaDlg::OnPlus2() 
{
	UpdateData(TRUE);
	m_fa=m_fa+1.0;	
	UpdateData(FALSE);
	OnAppliquer();
}
//________________________________________
void CParaDlg::OnPlus3() 
{
	UpdateData(TRUE);
	m_flv=m_flv+1.0;	
	UpdateData(FALSE);
	OnAppliquer();
}
//________________________________________
void CParaDlg::OnMoins3() 
{
	UpdateData(TRUE);
	m_flv=m_flv-1.0;	
	UpdateData(FALSE);
	OnAppliquer();
}
//________________________________________
void CParaDlg::OnPlus4() 
{
	UpdateData(TRUE);
	m_fEchz=m_fEchz+200.0;	
	UpdateData(FALSE);
	OnAppliquer();
}
//________________________________________
void CParaDlg::OnMoins4() 
{
	UpdateData(TRUE);
	m_fEchz=m_fEchz-200.0;
	UpdateData(FALSE);
	OnAppliquer();
}
//________________________________________
void CParaDlg::OnPlus5() 
{
	UpdateData(TRUE);
	m_fl=m_fl+1.0;	
	UpdateData(FALSE);
	OnAppliquer();
}
//________________________________________
void CParaDlg::OnMoins5() 
{
	UpdateData(TRUE);
	m_fl=m_fl-1.0;	
	UpdateData(FALSE);
	OnAppliquer();
}
//________________________________________
void CParaDlg::OnModele1() 
{
	UpdateData(TRUE);
	TesterVariables();
	UpdateData(FALSE);
	OnAppliquer();	
}
//________________________________________
void CParaDlg::OnModele2() 
{
	UpdateData(TRUE);
	TesterVariables();
	UpdateData(FALSE);
	OnAppliquer();	
}
//________________________________________
void CParaDlg::MAJ(CBkDoc *pDoc) 
{
	short i,j;

	Message();
	switch ((pDoc->m_iType)&8)
	{
		case 0://Encastre
			m_s1="Long. &l poutre (mm) :";
			m_s2="&Dist. &a encast./flche (mm) :";
			m_radioModele=0;
		break;
		case 8://2 appuis
			m_s1="Long. &l entre appuis (mm) :";
			m_s2="&Dist. &a appui/flche (mm) :";
			m_radioModele=1;
		break;
	}
	m_fa=pDoc->m_fa;	
	m_fIp=pDoc->m_fIp;	
	m_fIpp=pDoc->m_fIpp;	
	m_fF1=pDoc->m_fF1;	
	m_fDf=pDoc->m_fDf*1000;	
	m_fLambda=pDoc->m_fLambda*1e6;	
	m_fEchz=pDoc->m_fEchz;
	m_fl=pDoc->m_fl;	
	m_flv=pDoc->m_flv;	
	m_fDecFr=pDoc->m_fDecFr;	
	m_radioTypeFrange=pDoc->m_radioTypeFrange;

	i=pDoc->m_sFrTab.GetSize();
	m_listePos.ResetContent();
	for (j=0;j<i;j++)
	{
		m_listePos.AddString(pDoc->m_sFrTab.GetAt(j));
	}
	//Ecriture de la premire valeur dans la zone de texte
	if (i!=0) m_listePos.GetText(0,m_sPos);	

	if ((pDoc->m_iType&8)==8)
	{
		GetDlgItem(IDC_STATIC98)->SetWindowText("Poutre sur 2 appuis");
		m_radioModele=0;
	}
	else
	{
		GetDlgItem(IDC_STATIC98)->SetWindowText("Poutre encastre");
		m_radioModele=1;
	}
	UpdateData(FALSE);
}
